<template>
    <q-scroll-area class="fit">
        <q-item-label header>Graph Settings</q-item-label>
        <RadioSetting
            label="Color Mode"
            caption="The colors of the graph"
            :options="ColorMode"
            v-model="GraphSettings.StoreValue.colorMode"
        />
        <ToggleSetting
            label="Stack Graphs"
            caption="To stack graph (merge them and differentiate with color)"
            v-model="GraphSettings.StoreValue.stack"
        />
        <ToggleSetting
            label="Shorten Duration"
            caption="Show shorten-ed duration"
            v-model="GraphSettings.StoreValue.shortenDuration"
        />
        <SliderSetting
            label="Bar Opacity"
            caption="Opacity of bar graphs"
            v-model="GraphSettings.StoreValue.barAlpha"
            :min="0" :max="1" :step="0.05"
        />
        <SliderSetting
            label="Polar Area Opacity"
            caption="Opacity of polar area charts"
            v-model="GraphSettings.StoreValue.polarAlpha"
            :min="0" :max="1" :step="0.05"
        />
        <SliderSetting
            label="Radar Opacity"
            caption="Opacity or Radar charts"
            v-model="GraphSettings.StoreValue.radarAlpha"
            :min="0" :max="1" :step="0.05"
        />
        <SliderSetting
            label="Line Opacity"
            caption="Opacity of area under line graphs"
            v-model="GraphSettings.StoreValue.lineAlpha"
            :min="0" :max="1" :step="0.05"
        />
        <SliderSetting
            label="Pie/Doughnut Opacity"
            caption="Opacity of pie charts and doughnut graphs"
            v-model="GraphSettings.StoreValue.pieAlpha"
            :min="0" :max="1" :step="0.05"
        />
        <ToggleSetting
            label="Label Graph"
            caption="Label the graph with values"
            v-model="GraphSettings.StoreValue.labelGraph"
        />
        <ToggleSetting
            label="Show 0 Labels"
            :disable="!ShowLabel"
            caption="Label data sets with 0 value"
            v-model="GraphSettings.StoreValue.zeroLabel"
        />
        <ColorSetting label="Label Color"
                      caption="Color of the label's text"
                      :disable="!ShowLabel"
                      v-model="GraphSettings.StoreValue.labelColor"
        />
        <ColorSetting label="Label Background Color"
                      caption="Background Color of the label's text"
                      :disable="!ShowLabel"
                      v-model="GraphSettings.StoreValue.labelBackgroundColor"
        />
        <SliderSetting
            :disable="!ShowLabel"
            label="Label Background Opacity"
            caption="Opacity of Label's background Color"
            v-model="GraphSettings.StoreValue.labelBackgroundTransparency"
            :min="0" :max="1" :step="0.05"
        />
        <SliderSetting
            :disable="!ShowLabel"
            label="Label Size"
            caption="Font Size of labels"
            v-model="GraphSettings.StoreValue.labelSize"
            :min="4" :max="100" :step="4"
        />
        <SliderSetting
            label="Line tension"
            caption="Line tension of line graphs"
            v-model="GraphSettings.StoreValue.tension"
            :min="0" :max="2" :step="0.1"
        />
        <ColorSetting
            label="Heatmap Color"
            caption="Color used to heatmap"
            v-model="GraphSettings.StoreValue.matrixColor"
        />
        <SliderSetting
            label="Border Thickness"
            caption="Border thickness of charts"
            :min="0" :max="10" :step="0.5"
            v-model="GraphSettings.StoreValue.borderThickness"
        />
        <SliderSetting
            label="Line Thickness"
            caption="Thickness of lines in line graph"
            :min="0.5" :max="10" :step="0.5"
            v-model="GraphSettings.StoreValue.lineThickness"
        />
        <ToggleSetting
            label="Show Legend"
            caption="Whether to display legend"
            v-model="GraphSettings.StoreValue.legend"
        />
        <ToggleSetting
            label="Show Title"
            caption="Whether to display title"
            v-model="GraphSettings.StoreValue.title"
        />

        <SliderSetting
            :disable="!ShowTitle"
            label="Title Font Size"
            caption="Font size for graph title"
            v-model="GraphSettings.StoreValue.titleFontSize"
            :min="4" :max="100" :step="4"
        />
        <ColorSetting
            :disable="!ShowTitle"

            label="Title Color"
            caption="Color of graph title text"
            v-model="GraphSettings.StoreValue.titleColor"
        />
        <RadioSetting label="Title Position"
                      :disable="!ShowTitle"
                      :options="TitlePosition"
                      caption="Position of graph title"
                      v-model="GraphSettings.StoreValue.titlePosition"

        />

    </q-scroll-area>
</template>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import RadioSetting from "components/Filters/RadioSetting.vue";
import {GraphColorMode} from "src/classLibrary/Charting/GraphSetting";
import SliderSetting from "components/Filters/SliderSetting.vue";
import ToggleSetting from "components/Filters/ToggleSetting.vue";
import ColorSetting from "components/Filters/ColorSetting.vue";
import {TitlePositionType} from "src/classLibrary/Constants";

@Component({
    components: {ColorSetting, ToggleSetting, SliderSetting, RadioSetting}
})
export default class ChartFilter extends Vue {

    get ShowLabel() {
        return this.GraphSettings.StoreValue.labelGraph;
    }

    get ShowTitle() {
        return this.GraphSettings.StoreValue.title;
    }

    get TitlePosition() {
        return TitlePositionType;
    }

    get ColorMode(): { label: string, description: string, value: GraphColorMode }[] {
        return [
            {
                label: 'SubContractor/Zone',
                description: 'Use the colors of the respective SubContractor and zones',
                value: 'original',
            },
            {
                label: 'Distinct',
                description: 'Use a platelet of randomly generated visually distinct colors',
                value: 'distinct',
            },
            {
                label: 'Color Blind',
                description: 'Use a platelet of randomly generated visually distinct colors that is color-blind friendly',
                value: 'colorblind',
            },

        ]
    }
}
</script>

<style lang='scss' scoped>

</style>
